﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;

namespace TapfloDB.Data
{
    public class User
    {
        public int ID { get; set; }
        public string Login { get; set; }
        public string Name { get; set; }
        public string EMail { get; set; }
        public string Type { get; set; }
        public UserMode Mode { get; set; }
        public List<string> DB { get; set; }
        public List<string> Access { get; set; }

        public User(){
            Mode = UserMode.Active | UserMode.ChangePass;
            DB = new List<string>();
            Access = new List<string>();
        }
        public User(DataRow u) : this(){
            ID = (int)u["id"];
            Login = (string)u["login"];
            Name = (string)u["name"];
            EMail = (string)u["email"];
            Type = (string)u["type"];
            Mode = (UserMode)u["mode"];
            string ac = (string)u["access"];
            Access.AddRange(ac.Split(','));
        }

        public string GetDefaultView(){
            try {
                return Access.First(x => !x.StartsWith("#"));
            }
            catch {
                return null;
            }
        }

        /*
        public User(string login, string name) {
            Login = login;
            Name = name;
        }
        */

        public override string ToString(){
            return String.Format("{0} ({1})", Name, Login);
        }
    }
}
