﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TapfloDB
{
    public partial class Login : Form
    {
        public Login(){
            DialogResult = DialogResult.Abort;
            InitializeComponent();
            lappv.Text = String.Format("TapfloDB {0}", Server.AppVersion);
        }

        private void Login_Shown(object sender, EventArgs e){
            tlogin.Focus();
        }

        private void blogin_Click(object sender, EventArgs e){
            if(tlogin.Text.Length == 0 || tpass.Text.Length == 0){
                MessageBox.Show("Login i/lub Hasło nie może być puste!", "Pusty Login/Hasło", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                return;
            }

            try {
                if (Server.Login(tlogin.Text, tpass.Text)){
                    DialogResult = DialogResult.OK;
                    Session.Curr.Action("Pomyślnie zalogowano jako " + tlogin.Text);

                    // Force Password Change?
                    if (Session.Curr.User.Mode.CompareTo(Data.UserMode.ChangePass) > 0){
                        Password p = new Password(FormMode.Change, tpass.Text);
                        if (DialogResult.OK == (DialogResult = p.ShowDialog()))
                            Session.Curr.Action("Pomyślnie ustawiono nowe hasło");
                    }
                }
                else
                    MessageBox.Show("Błędny login lub hasło!", "Nieudane logowanie", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
            catch (Exception exp){
                Server.Log("Nieznany błąd logowania - {0}", exp.Message);
                MessageBox.Show("Podczas próby logowania wystąpił nieoczekiwany błąd.\nSpróbuj ponownie za kilka minut jeśli ten błąd bedzie się powtarzał skontaktuj się z Administratorem.", "Nieoczekiwany błąd logowania.", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
            }
        }

        private void Login_KeyDown(object sender, KeyEventArgs e){
            if (e.KeyCode == Keys.Escape)
                Close();
        }
    }
}
