﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TapfloDB
{
    public class PSqlArrays
    {
        public static int?[] ParseInt(object o, int length){
            if (o == null || o is DBNull) 
                return new int?[length];

            object[] tmp;
            Type t = o.GetType(); 
            if (t.IsArray){
                if (typeof(short).IsAssignableFrom(t.GetElementType())){
                    var ret = from i in ((short[])o) select (int?)i;
                    return (ret.Count() < length ? ret.Union(new int?[length - ret.Count()]) : ret).ToArray();
                }
                else if (typeof(int).IsAssignableFrom(t.GetElementType())){
                    var ret = from i in ((int[])o) select (int?)i;
                    return (ret.Count() < length ? ret.Union(new int?[length - ret.Count()]) : ret).ToArray();
                }
                else
                    tmp = (object[])o;
            }
            else if (o is string){
                string array = o as string;
                if (array == "{}")
                    return null;

                array = array.Substring(1, array.Length - 2);
                tmp = array.Split(',');
            }
            else
                return null;

            int val;
            int?[] res = new int?[Math.Max(tmp.Length, length)];
            for (int i = 0; i < tmp.Length; ++i){
                if (tmp[i] is int)
                    res[i] = (int)tmp[i];
                else if (tmp[i] != null && Int32.TryParse(tmp[i].ToString(), out val))
                    res[i] = val;
                else
                    res[i] = null;
            }

            return res;
        }

        public static string[] ParseString(object array, int length){
            if (array is string[]){
                string[] arr = array as string[];
                if (arr.Length < length)
                    return arr.Concat(new string[length - arr.Length]).ToArray();
                else
                    return arr;
            }
            else //if (array == null || array is DBNull) 
                return new String[length];
        }

    }
}
