﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TapfloDB.View
{
    public partial class AbstractView : UserControl
    {
        #region Properties

        public bool SupportExport { get; protected set; }
        public bool NewWindow { get; protected set; }

        [EditorBrowsable(EditorBrowsableState.Always)]
        [Browsable(true)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)]
        [Bindable(true)]
        public override string Text {
            get { return base.Text; }
            set { base.Text = value; }
        }

        #endregion

        public AbstractView(){
            InitializeComponent();
            SupportExport = false;
            NewWindow = false;
        }

        public virtual void Export() { 
            
        }

        public virtual void RefreshData(){

        }
    }
}
