﻿using System;
using System.ComponentModel;
using System.Collections.Generic;

namespace TapfloDB.View.Users
{
    public class UserType {
        private static List<UserType> values = new List<UserType>(3);
        private static Dictionary<string, UserType> descs = new Dictionary<string, UserType>(3);

        public static readonly UserType Unknown = new UserType("Nieznany");
        public static readonly UserType Admin = new UserType("Administrator");
        public static readonly UserType User = new UserType("Użytkownik");

        public int Id { get; private set; }
        public string Description { get; private set; }

        private UserType() { }
        private UserType(string desc) {
            Id = UserType.values.Count;
            Description = desc;
        
            values.Add(this);
            descs.Add(desc, this);
        }

        public override string ToString(){
            return Description;
        }

        public static implicit operator String(UserType ut) {
            return ut.ToString();
        }

        public static implicit operator UserType(int ut){
            if (ut > -1 && ut < values.Count)
                return values[ut];
            
            return null;
        }

        public static explicit operator UserType(string ut){
            UserType t = null;
            descs.TryGetValue(ut, out t);
            return t;
        }
    }
}